From 3ef946a0519e5aac86f29bd6db444697c3f356fb Mon Sep 17 00:00:00 2001
From: Fabio Ritrovato <exsephiroth87@gmail.com>
Date: Wed, 3 Feb 2010 23:46:28 +0100
Subject: [PATCH] [GSoC] luasd: the new Shoutcast Radio script

---
 share/lua/sd/shoutcast_radio.lua |   54 ++++++++++++++++++++++++++++++++++++++
 1 files changed, 54 insertions(+), 0 deletions(-)
 create mode 100644 share/lua/sd/shoutcast_radio.lua

diff --git a/share/lua/sd/shoutcast_radio.lua b/share/lua/sd/shoutcast_radio.lua
new file mode 100644
index 0000000..abbf305
--- /dev/null
+++ b/share/lua/sd/shoutcast_radio.lua
@@ -0,0 +1,54 @@
+--SD_Description=Shoutcast Radio
+--[[
+ $Id$
+
+ Copyright © 2009 the VideoLAN team
+ 
+ Authors: Fabio Ritrovato <exsephiroth87@gmail.com>
+
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+--]]
+SHOUTCAST_BASE_URL = "http/shout-winamp://www.shoutcast.com/sbin/newxml.phtml"
+
+function main()
+    local fd = vlc.stream( "http://www.shoutcast.com/sbin/newxml.phtml" )
+    local page = ""
+    local newpage = fd:read( 65653 )
+    while newpage ~= nil and newpage ~= "" do
+        page = page .. newpage
+        newpage = fd:read( 65653 )
+    end
+    fd = nil
+    if page == "" then
+        return nil
+    end
+    local oldidxEnd = 0, i, j
+    while true do
+        local idxEnd, genre
+        _, i = string.find ( page, "<genre name=\"", oldidxEnd )
+        j, idxEnd = string.find ( page, "\"></genre>", oldidxEnd )
+        if idxEnd ~= nil and oldidxEnd ~= nil and idxEnd > oldidxEnd then
+            genre = string.sub( page, i+1, j-1) 
+            if genre then
+                oldidxEnd = idxEnd
+            else
+                break
+            end
+        else
+            break
+        end
+        vlc.sd.add_item( {title=genre,url=SHOUTCAST_BASE_URL .. "?genre=" .. genre} )
+    end
+end
-- 
1.6.0.4

